#include <mega128.h>
#include <UART.h>
#include "displ.h"
#include "def.h"
#include "LCD_3320.h"
#include "delay.h"

extern __flash const char *menuT4[];
extern eeprom MODEL_SET EEPR_models[];
extern unsigned char dpos[6];
__flash char _str_tx_to_pc1[]="Connect TX to PC";
__flash char _str_tx_to_pc2[]="or to Slave TX";
__flash char _str_tx_tx[]="TX <   > TX";
__flash char _str_pc_tx[]="TX <   > PC";
__flash char _str_exit[]="Press <- to Exit";
__flash char _str_load1[]="Connect this TX";
__flash char _str_load2[]="to master TX";
__flash char _str_load3[]="and press ->";
__flash char _str_load_finished[]="Load is OK!";


extern MODEL_SET cur_model; 
extern unsigned char cur_model_ind;
extern void SetCRC_EEPROM();


//   UART1

char flaguart=0;
void putchar1(char c);
char getchar1(void);
char status,data;

#define RXB8 1
#define TXB8 0
#define UPE 2
#define OVR 3
#define FE 4
#define UDRE 5
#define RXC 7

#define FRAMING_ERROR (1<<FE)
#define PARITY_ERROR (1<<UPE)
#define DATA_OVERRUN (1<<OVR)
#define DATA_REGISTER_EMPTY (1<<UDRE)
#define RX_COMPLETE (1<<RXC)

// Get a character from the USART1 Receiver
#pragma used+

char getchar1(void)
{
while (1)
      {
      //if (KEY_LEFT) return; 
      while (((status=UCSR1A) & RX_COMPLETE)==0);
      data=UDR1;
      if ((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0)
         return data;
      };
}
#pragma used-

// Write a character to the USART1 Transmitter
#pragma used+
void putchar1(char c)
{
while ((UCSR1A & DATA_REGISTER_EMPTY)==0);
UDR1=c;
}
#pragma used-

char transmit(char *mem, unsigned int size)
{
while(size)
{
putchar1(*mem);
//     1
mem++;
size--;
}
return 0;
}

char receive(char *mem, unsigned int size)
{
while(size)
{
*mem=getchar1();
//     1
mem++;
size--;
}
return 0;
}


void loadconfig(void)
{
    LCD_clear();
    delay_ms(500);
    displ_head(menuT4[5]);
    LCD_setxy(10,20); LCD_wrsf(_str_load1, 1);
    LCD_setxy(18,30); LCD_wrsf(_str_load2, 1);
    LCD_setxy(19,40); LCD_wrsf(_str_load3, 1);
    LCD_refresh();
    
while (1)
  {
      if (!KEY_LEFT)
       {
       delay_ms(300);
       return; 
       }
      if (!KEY_RIGHT) 
       {
       delay_ms(300);
       putchar1(0x41);
       LCD_clear();
       displ_head(menuT4[4]);
       LCD_setxy(25,20); LCD_wrsf(_str_tx_tx, 1);
       LCD_line(41,23, 54,23, 1);
       LCD_refresh();
       receive((char*)&cur_model, sizeof(MODEL_SET));
       EEPR_models[cur_model_ind]=cur_model; //Save cur_model to EEPROM
       SetCRC_EEPROM();
       LCD_setxy(25,20); LCD_wrsf(_str_load_finished, 1);
       LCD_setxy(12,40); LCD_wrsf(_str_exit, 1);
       LCD_refresh();
       }
      
   } 
flaguart=0;
}

void globaluart(void)
{
    //  
    LCD_clear();
    LCD_refresh();
    //delay_ms(500);
    displ_head(menuT4[4]);
    LCD_setxy(10,20); LCD_wrsf(_str_tx_to_pc1, 1);
    LCD_setxy(16,30); LCD_wrsf(_str_tx_to_pc2, 1);
    LCD_refresh();
    
while (1)
      {
      while (((status=UCSR1A) & RX_COMPLETE)==0)
      {
      if (!KEY_LEFT)
       {
       delay_ms(300);
       return; 
       }
      if (data==0x61)
       {
       data=0x00;
       return; 
       } 
      }
      data=UDR1;
      if ((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0)
         {
           switch (data) {
            case 0x31: //   
            LCD_clear();
            LCD_refresh();
            displ_head(menuT4[4]);
            LCD_setxy(25,20); LCD_wrsf(_str_pc_tx, 1);
            LCD_line(41,23, 54,23, 1);
            LCD_setxy(12,40); LCD_wrsf(_str_exit, 1);
            LCD_refresh();
            break;
            
            case 0x41: //  TX
            LCD_clear();
            LCD_refresh();
            displ_head(menuT4[4]);
            LCD_setxy(25,20); LCD_wrsf(_str_tx_tx, 1);
            LCD_line(41,23, 54,23, 1);
            LCD_setxy(12,40); LCD_wrsf(_str_exit, 1);
            LCD_refresh();
            break;
                        
            case 0x32: //  
            transmit((char*)&cur_model, sizeof(MODEL_SET));
            break;
            
            case 0x33: //  
            receive((char*)&cur_model, sizeof(MODEL_SET));
            
            EEPR_models[cur_model_ind]=cur_model; //Save cur_model to EEPROM
            SetCRC_EEPROM();
            break;
            
            }
         }
      };
flaguart=0;
}