//"Reset\t>"
#include <mega128.h>
#include <delay.h>
#include <string.h>
#include <stdio.h>
#include "def.h"
#include "LCD_3320.h"
#include "displ.h"
#include "UART.h"


//  !!
extern eeprom MODEL_SET EEPR_models[MAX_MODELS];
extern signed int out_ch[MAX_CHANS];
extern unsigned int cur_Batt;
extern unsigned int cur_Antenna;
extern unsigned int cur_Temperature;
extern signed int dir_Temperature;
extern MODEL_SET cur_model;
extern unsigned char BatCntr[3];
extern unsigned char gAntCntr;
extern bit f_TCut;
extern unsigned int time;
extern bit  f_sound_en;
extern bit  f_throttle_en;
extern unsigned char g_MainMenuMode;
extern unsigned int gRPM[];
extern signed int CalibrTemperature[2];  
// 

__flash const char *modeNames[2][3] = 
   {
     { " Landing", "  Normal", "Pilotage" },
     { "  Normal", "Iddle Up", "Th. Hold" }
    }; 
__flash const char *modulNames[] = { "PPM", "i-PPM", "PCM" };
__flash const char *menuT0[] = {
    "Select\t>",
    "Model\t>",
    "Copy\t>",
    "Options\t>"
};
__flash const char *menuT1[] ={
    "Controls\t>",
    "Channels\t>",
    "Name\t>",
    "Type\t>",
//    "Frequency\t>",
    "Modulation\t>",
    "Max channel\t>",
    "Timer\t>",
    "Modes copy\t>",
    "Reset\t>"
};
__flash const char *menuT2[] = {
    "Ailerons\t>",
    "Elevator\t>",
    "Throttle\t>",
    "Rudder\t>",
    "Switch 1\t>",
    "Switch 2\t>",
    "Switch 3\t>",
    "Add Prop\t>",
    "Virtual 1\t>",
    "Virtual 2\t>",
};
__flash const char *menuCh[]= {
    "Mixer\t>",
    "Normalize\t>",
    "Subtrimmer",
    "EPA-",
    "EPA+",
    "Reverse"
}; 
__flash const char *menuT3[] = {
    "Set timer\t>",
    "Timer modes\t>"
};
__flash const char *menuT4[] = {
    "Sound\t>",
    "Alarms\t>",
    "Monitor\t>",
    "Tachometer\t>",
    "PC/TX Link\t>",
    "Load Config\t>",
    "Version\t>"
};
__flash const char *menuT5[] = {
    "Channel 1\t>",
    "Channel 2\t>",
    "Channel 3\t>",
    "Channel 4\t>",
    "Channel 5\t>",
    "Channel 6\t>",
    "Channel 7\t>",
    "Channel 8\t>"    
};
__flash const char *menuT6[] = {
    "Battery\t>",
    "Throttle\t>"
};

__flash const char *TypesModel[] = { "Plane", "Helicopter" };
__flash const char *Timer_modes1[] = { "UP", "DOWN","AUTO" };
//__flash const char *Timer_modes2[] = { "Sound ON", "Sound OFF" };
__flash const char *menuT7[]= { "Save", "Cancel", "Restore" };
__flash const char *menuT8[]= { "Warning", "Alarm", "Max" };
__flash char _str_VER[]="V1.9.1+, 25/10/10";
__flash char _str_Co[]="(c) MSV";


//-------------------------------------------------------------
unsigned char dg_list_topitem;
unsigned char dg_list_selitem;
unsigned char dg_list_cnt;
bit df_edit;
bit df_edit_cur;
bit df_clip;
unsigned char dpos[6];
unsigned char dT[2];
MODEL_SET dcur_model;
DEF_MODE *dcur_mode;
unsigned char dcur_mode_ind;
unsigned char tmp[12];


//-------------------------------------------------------------
void list_draw_scrollbar (void)
{
unsigned char l;
unsigned int pos;

l=MAX_LIST_LINES*9; 
LCD_line(94, 11, 94, 11+l-1, 1);
if(dg_list_cnt<=MAX_LIST_LINES) return;
pos=l-(5+2); 
//pos*=dg_list_topitem; pos/=(dg_list_cnt-MAX_LIST_LINES); pos+=12;
pos*=dg_list_selitem; pos/=(dg_list_cnt-1); pos+=12;
LCD_line(93, pos, 93, pos+4, 1);
LCD_line(94, pos, 94, pos+4, 0);
LCD_line(95, pos, 95, pos+4, 1);
}
//-------------------------------------------------------------
void list_displ(__flash const char **list)
{
unsigned char i, y, att, n;

n=dg_list_topitem;
for(i=0, y=11; i<MAX_LIST_LINES && n<dg_list_cnt; i++, n++, y+=9)
  {
  LCD_setxy(5, y);
  if(n==dg_list_selitem) { att=0; LCD_fillrect(0, y-1, 78, y+7, 1); }
  else att=1;
  LCD_wrsf(list[n], att);
  }
list_draw_scrollbar();  
}
//-------------------------------------------------------------
void list_displ_names (void)
{
unsigned char i, j, y, att, n;

n=dg_list_topitem;
for(i=0, y=11; i<MAX_LIST_LINES && n<dg_list_cnt; i++, n++, y+=9)
  {
  LCD_setxy(2, y);
  if(n==dg_list_selitem) { att=0; LCD_fillrect(0, y-1, 78, y+7, 1); }
  else att=1;
  for(j=0; j<8; j++) LCD_char(EEPR_models[n].name[j], att);
  }
list_draw_scrollbar();  
}
//-------------------------------------------------------------
void displ_contr_short(unsigned char ind, unsigned char x, unsigned char y, unsigned char att)
{
flash char *p;
LCD_setxy(x,y); p=menuT2[ind];
while(*p>=' ') { LCD_char(*p, att); p++; }
if(att==0) LCD_frame(x);
}
//-------------------------------------------------------------
void displ_controls (char N, char sel)
{
unsigned char  att, ind;

if (N<=3 && N!=2)
  { //     
  ind=N; if(N>2) ind=2;
  LCD_setxy(0+4,20+4); LCD_wrsf("Rate", 1);  
  sprintf(tmp,"%-i",dcur_mode->contr_ab[ind].minRates);
  if (sel==0) { att=0; if(df_edit) att=df_clip; } else att=1;
  LCD_setxy(39+4,20+4); LCD_wrs(tmp, att);
  sprintf(tmp,"%-i",dcur_mode->contr_ab[ind].maxRates);
  if (sel==1) { att=0; if(df_edit) att=df_clip; } else att=1;
  LCD_setxy(62+4,20+4); LCD_wrs(tmp, att);      
  LCD_setxy(0+4, 29+4); LCD_wrsf("DRate", 1); 
  sprintf(tmp,"%-i",dcur_mode->contr_ab[ind].minDRates);
  if (sel==2) { att=0; if(df_edit) att=df_clip; } else att=255;
  LCD_setxy(39+4, 29+4); LCD_wrs(tmp, att);
  sprintf(tmp,"%-i",dcur_mode->contr_ab[ind].maxDRates);   
  if (sel==3) { att=0; if(df_edit) att=df_clip; } else att=255;
  LCD_setxy(62+4, 29+4); LCD_wrs(tmp, att);
  if (sel==4) att=0; else att=1;
  LCD_setxy(39+4, 38+4); LCD_wrsf("Curve >", att);  
  }
else if (N==2)
  { // 
  LCD_setxy(0+4,20+4); LCD_wrsf("Rate", 1);  
  sprintf(tmp,"%-i",dcur_mode->contr_tr.minRates);
  if (sel==0) { att=0; if(df_edit) att=df_clip; } else att=1;
  LCD_setxy(39+4,20+4); LCD_wrs(tmp, att);
  sprintf(tmp,"%-i",dcur_mode->contr_tr.maxRates);
  if (sel==1) { att=0; if(df_edit) att=df_clip; } else att=1;
  LCD_setxy(62+4,20+4); LCD_wrs(tmp, att);
  LCD_setxy(0+4, 29+4); LCD_wrsf("Tcut", 1); 
  sprintf(tmp,"%-i",dcur_mode->contr_tr.tcut);
  if (sel==2) { att=0; if(df_edit) att=df_clip; } else att=1;
  LCD_setxy(39+4, 29+4); LCD_wrs(tmp, att);
  if (sel==3) att=0; else att=1;
  LCD_setxy(39+4, 38+4);  LCD_wrsf("Curve >", att);  
  }
else if(N>=4 && N<=6)
  { //  
  ind=N-4;
  LCD_setxy(0+4,20+4); LCD_wrsf("Rate", 1);  
  sprintf(tmp,"%-i",dcur_mode->contr_d[ind].minRates);
  if (sel==0) { att=0; if(df_edit) att=df_clip; } else att=1;
  LCD_setxy(39+4,20+4); LCD_wrs(tmp, att);
  sprintf(tmp,"%-i",dcur_mode->contr_d[ind].maxRates);
  if (sel==1) { att=0; if(df_edit) att=df_clip; } else att=1;
  LCD_setxy(62+4,20+4); LCD_wrs(tmp, att);
  LCD_setxy(0+4, 29+4); LCD_wrsf("Delay", 1); 
  sprintf(tmp,"%i.%i",dcur_mode->contr_d[ind].delay/10, dcur_mode->contr_d[ind].delay%10);
  if (sel==2) { att=0; if(df_edit) att=df_clip; } else att=1;
  LCD_setxy(39+4, 29+4); LCD_wrs(tmp, att);
  }
else if (N==7)
  { //  
  LCD_setxy(0+4,20+4); LCD_wrsf("Rate", 1);  
  sprintf(tmp,"%-i",dcur_mode->contr_ap.minRates);
  if (sel==0) { att=0; if(df_edit) att=df_clip; } else att=1;
  LCD_setxy(39+4,20+4); LCD_wrs(tmp, att);
  sprintf(tmp,"%-i",dcur_mode->contr_ap.maxRates);
  if (sel==1) { att=0; if(df_edit) att=df_clip; } else att=1;
  LCD_setxy(62+4,20+4); LCD_wrs(tmp, att);      
  if (sel==2) att=0; else att=1;
  LCD_setxy(39+4, 38+4);  LCD_wrsf("Curve >", att);  
  }
else if(N>=8)
  { //  
  ind=N-8;
  LCD_setxy(0+4,20+4); LCD_wrsf("Rate", 1);  
  sprintf(tmp,"%-i",dcur_mode->contr_v[ind].minRates);
  if (sel==0) { att=0; if(df_edit) att=df_clip; } else att=1;
  LCD_setxy(39+4,20+4); LCD_wrs(tmp, att);
  sprintf(tmp,"%-i",dcur_mode->contr_v[ind].maxRates);
  if (sel==1) { att=0; if(df_edit) att=df_clip; } else att=1;
  LCD_setxy(62+4,20+4); LCD_wrs(tmp, att);      
  LCD_setxy(0+4, 29+4); LCD_wrsf("From:", 1);
  if (sel==2) { att=0; if(df_edit) att=df_clip; } else att=1; 
  displ_contr_short(dcur_mode->contr_v[ind].from, 39+4, 29+4, att);
  if (sel==3) att=0; else att=1;
  LCD_setxy(39+4, 38+4); LCD_wrsf("Curve >", att);  
  }
}
//-------------------------------------------------------------   
void displ_curve (unsigned char N, unsigned char sel)
{
char Y[7];
int i;
unsigned char x, att, ind;
char *val;

if (N<=3 && N!=2)
  {
  ind=N; if(N>2) ind=2;
  val=dcur_mode->contr_ab[ind].cur_nodes;
  }
else if(N==2) val=dcur_mode->contr_tr.cur_nodes;
else if(N==7) val=dcur_mode->contr_ap.cur_nodes;
else if(N>=8) val=dcur_mode->contr_v[N-8].cur_nodes;
LCD_rectangle(5+6,12+6, 77+6, 38+6, 1);
LCD_dashline(5+6, 25+6, 77+6, 25+6);
for(i=0, x=17; i<5; i++, x+=12) LCD_dashline(x+6, 12+6, x+6, 38+6);   
for(i=0; i<7; i++) Y[i]=25-(val[i+1]/8);
for(i=0, x=5; i<6; i++, x+=12) LCD_line(x+6, Y[i]+6, x+12+6, Y[i+1]+6, 1);
if(sel)
  {
  sprintf(tmp,"%i",val[sel]);
  i=sel-1;
  LCD_rectangle(3+i*12+6, Y[i]+2+6, 7+i*12+6, Y[i]-2+6,1);
  LCD_setxy(2+6, 40+6);
  if (!df_edit) att=1; else att=df_clip;
  LCD_wrs(tmp, att);
  }
else
  {
  LCD_setxy(2+26, 40+10); LCD_wrsf("Exp:", 1);
  if (!df_edit) att=0; else att=df_clip;
  LCD_setxy(24+26, 40+10);
  if(val[sel]>100) LCD_wrsf("free", att);
  else
    { sprintf(tmp,"%i", val[sel]); LCD_wrs(tmp, att); }
  }   
}
//-------------------------------------------------------------   
void displ_channel (char ch_ind)
{
unsigned char i, n, y, att;
CHANNEL *ch;

ch=&dcur_model.channels[ch_ind];
for(i=0, n=dg_list_topitem, y=11; i<MAX_LIST_LINES && n<dg_list_cnt; i++, n++, y+=9)
  {
// Name  
  LCD_setxy(2,y);
  att=1;
  if(n<2)
    {
    if(n==dg_list_selitem) { att=0; LCD_fillrect(0, y-1, 78, y+7, 1); }
    LCD_wrsf(menuCh[n], att); 
    }
  else
    {
    if(n==dg_list_selitem && !df_edit) { att=0; LCD_fillrect(0, y-1, 46, y+7, 1); }
    LCD_wrsf(menuCh[n], att);
    LCD_setxy(48+8, y);
//Param  
    if(n==dg_list_selitem && df_edit) att=df_clip; else att=1;
    switch(n)
      {
    case 2: sprintf(tmp, "%i", ch->subtrimmer); break;    
    case 3: sprintf(tmp, "%i", ch->epa[0]); break;    
    case 4: sprintf(tmp, "%i", ch->epa[1]); break;    
    case 5: if(ch->reverse==-1) strcpyf(tmp, "Yes"); else strcpyf(tmp, "No"); break;    
      }
    LCD_wrs(tmp, att);
    }
  }
list_draw_scrollbar();  
} 
//-------------------------------------------------------------   
void displ_mixer (unsigned char ch_ind)
{
unsigned char i, n, y, att;
flash char *p;

for(i=0, n=dg_list_topitem, y=11; i<MAX_LIST_LINES && n<dg_list_cnt; i++, n++, y+=9)
  {
  LCD_setxy(2,y);
  if(n==dg_list_selitem && !df_edit) { att=0; LCD_fillrect(0, y-1, 46, y+7, 1); } else att=1;
  p=menuT2[n];
  while(*p>=' ') { LCD_char(*p, att); p++; }
  if(n==dg_list_selitem && df_edit) att=df_clip; else att=1;
  LCD_setxy(48, y);
  sprintf(tmp, "%i", dcur_mode->mixer[ch_ind][n]);
  LCD_wrs(tmp, att);
  }
list_draw_scrollbar();  
} 
//-------------------------------------------------------------   
void displ_monitor(void)
{
unsigned char i, j, y, n, y1, x;
signed int v;
signed long z;

for(i=0, n=dg_list_selitem, y=11; i<MAX_LIST_LINES && n<dcur_model.num_ch; i++, n++, y+=9)
  {
  v=out_ch[n]-2250; // +- 900
  //if(dpos[3]==0)
  switch(dpos[3])
  {
    case 0:
     {
    sprintf(tmp, "%-i", n+1);
    LCD_setxy(2,y); LCD_wrs(tmp, 1);
    y1=y+7;
    LCD_line(14, y1, 78, y1, 1);
    for(j=0, x=14; j<17; j++, x+=4)
      { LCD_pixel(x, y1-1, 1); if(!(j%2)) LCD_pixel(x, y1-2, 1); }
    v*=32; v/=900; v+=46;
    LCD_pixel(v, y1-1-2, 1);
    LCD_line(v-1, y1-2-2, v+1, y1-2-2, 1);
    LCD_line(v-2, y1-3-2, v+2, y1-3-2, 1);
    }
    break;
    case 1:
  //else   
    {    
    v*=10; v/=75;
    sprintf(tmp, "Ch%-i %-i %%", n+1, v);
    LCD_setxy(2,y); LCD_wrs(tmp, 1);
    }
    break;
    
    case 2:
    {
    z=out_ch[n];
    z*=6667; z/=10000;
        
    sprintf(tmp, "Ch%-i %-i us", n+1,z);
    LCD_setxy(2,y); LCD_wrs(tmp, 1);    
    }
  }
  }
}   
//-------------------------------------------------------------
void displ_trimmer (void)
{
unsigned char i, x, y, v;

// left, vert 
x=0;
LCD_line(x, 11+12, x, 43+12, 1);
for(i=0, y=11; i<9; i++, y+=4)
  { LCD_pixel(x+1, y+12, 1); if(!(i%2)) LCD_pixel(x+2, y+12, 1); }
v=(dcur_mode->trimmers[2]/-5)+27;
LCD_pixel(x+1+2, v+12, 1);
LCD_line(x+2+2, v-1+12, x+2+2, v+1+12,1);
LCD_line(x+3+2, v-2+12, x+3+2, v+2+12,1);
// right, vert
x=(WidthS-1); //83
LCD_line(x, 11+12, x, 43+12, 1);
for(i=0, y=11; i<9; i++, y+=4)
  { LCD_pixel(x-1, y+12, 1); if(!(i%2)) LCD_pixel(x-2, y+12, 1); }
v=(dcur_mode->trimmers[1]/-5)+27;
LCD_pixel(x-1-2, v+12, 1);
LCD_line(x-2-2, v-1+12, x-2-2, v+1+12, 1);
LCD_line(x-3-2, v-2+12, x-3-2, v+2+12, 1);
// left, horz
y=(HeightS-3); //47
LCD_line(4, y, 36, y, 1);
for(i=0, x=4; i<9; i++, x+=4)
  { LCD_pixel(x, y-1, 1); if(!(i%2)) LCD_pixel(x, y-2, 1); }
v=(dcur_mode->trimmers[3]/5)+20;
LCD_pixel(v, y-1-2, 1);
LCD_line(v-1, y-2-2, v+1, y-2-2, 1);
LCD_line(v-2, y-3-2, v+2, y-3-2, 1);
// right, horz
y=(HeightS-3); 
LCD_line((WidthS-37), y, (WidthS-5), y, 1);  // 47  79  
//for(i=0, x=47; i<9; i++, x+=4)
for(i=0, x=(WidthS-37); i<9; i++, x+=4)   
  { LCD_pixel(x, y-1, 1); if(!(i%2)) LCD_pixel(x, y-2, 1); }
//v=(dcur_mode->trimmers[0]/5)+63;        //******************************
v=(dcur_mode->trimmers[0]/5)+(WidthS-37+16); // !!!!!
LCD_pixel(v, y-1-2, 1);
LCD_line(v-1, y-2-2, v+1, y-2-2, 1);
LCD_line(v-2, y-3-2, v+2, y-3-2, 1);
}

void displ_trimmer_digital(void)
{
signed char v;
unsigned char offset ;
//offset=0; offset2=0;

// left, vert 
 LCD_setxy(2, 39);
 v=(dcur_mode->trimmers[2]);
 sprintf(tmp,"%i",  v);
 LCD_wrs(tmp, 1);

// left, horz 
 LCD_setxy(22, 56);
 v=(dcur_mode->trimmers[3]);
 sprintf(tmp,"%i",  v);
 if(v>=0) offset=28;
 if(v>9) offset=25;
 if(v<0) offset=23;
 if(v<-9) offset=20;
 LCD_setxy(offset, 56);  
 LCD_wrs(tmp, 1);

// right, vert 
  v=(dcur_mode->trimmers[1]);
 sprintf(tmp,"%i",  v);
  
 if(v>=0) offset=89;
 if(v>9) offset=84;
 if(v<0) offset=84;
 if(v<-9) offset=79; 
 LCD_setxy(offset, 39);
 LCD_wrs(tmp, 1);


// right, horz 
 v=(dcur_mode->trimmers[0]);
 sprintf(tmp,"%i",  v);
 if(v>=0) offset=64; //+8
 if(v>9) offset=61;  //+5
 if(v<0) offset=59;  //+3
 if(v<-9) offset=56; 
 
 LCD_setxy(offset, 56);
 LCD_wrs(tmp, 1);
                    
}


//-------------------------------------------------------------
/*sprintf(tmp,"%-i", VOut[0]);
LCD_setxy(0, 0);
LCD_wrs(tmp, 1);
sprintf(tmp,"%-i", VOut[1]);
LCD_setxy(0, 9);
LCD_wrs(tmp, 1);
sprintf(tmp,"%-i", VOut[2]);
LCD_setxy(0, 18);
LCD_wrs(tmp, 1);
sprintf(tmp,"%-i", VOut[3]);
LCD_setxy(0, 27);
LCD_wrs(tmp, 1);
sprintf(tmp,"%-i", VOut[4]);
LCD_setxy(0, 36);
LCD_wrs(tmp, 1);*/
//-------------------------------------------------------------
/*sprintf(tmp,"%-i", VOut[0]);
LCD_setxy(0, 0);
LCD_wrs(tmp, 1);
sprintf(tmp,"%-i", VOut[1]);
LCD_setxy(0, 9);
LCD_wrs(tmp, 1);
sprintf(tmp,"%-i", VOut[2]);
LCD_setxy(0, 18);
LCD_wrs(tmp, 1);
sprintf(tmp,"%-i", VOut[3]);
LCD_setxy(0, 27);
LCD_wrs(tmp, 1);
sprintf(tmp,"%-i", VOut[4]);
LCD_setxy(0, 36);
LCD_wrs(tmp, 1);*/
//-------------------------------------------------------------
void main_scr (void)
{
unsigned char i;
char min[2], sec[2];
signed int k;
//signed long l;
//char ch;
        
//  
LCD_setxy(0, 0);
if(dcur_model.type==1) { LCD_char(125,1); LCD_char(126,1); } //                                                                ///***************************
else  { LCD_char(127,1);  LCD_char(128,1); } // 
//        
LCD_setxy(24,0);
for(i=0; i<8; i++) LCD_char(dcur_model.name[i], 1);
LCD_dashline(0, 8, 95, 8);

// 
LCD_setxy(13,12);
if (cur_model.modulation==0) LCD_wrsf("PPM", 1);
          else if (cur_model.modulation==1) LCD_wrsf("iPPM", 1);

LCD_setxy(2, 11);
if (cur_model.modulation==0) LCD_char(136,1);
          else if (cur_model.modulation==1) LCD_char(137,1);


//                          
LCD_setxy(57,12);
if(f_TCut) LCD_wrsf("TCut", df_clip); //    
else LCD_wrsf(modeNames[dcur_model.type][dcur_mode_ind],1);
//   
//displ_trimmer();
//  
min[0]=(time/600)%10;
min[1]=(time/60)%10;
sec[0]=(time%60)/10;
sec[1]=time%10;
switch(g_MainMenuMode)
  {
case 0:
//   
displ_trimmer();
// 
//  LCD_setxy(5, 11); LCD_char(133, 1);
  /*
  sprintf(tmp,"%u%u:%u%u", min[0], min[1], sec[0], sec[1]);
  LCD_setxy(12, 12); LCD_wrs(tmp, 1);
  */
  //LCD_setxy(((WidthS/2)-30), 12); LCD_wrs(tmp, 1);
  LCD_setxy(((WidthS/2)-30),35);
  //LCD_setxy(12,24);
  LCD_deg12x16(min[0], 1);
  //LCD_setxy((((WidthS/2)-30)+12),35);
  LCD_setxy((((WidthS/2)-18)),35);
  LCD_deg12x16(min[1], 1);
  //LCD_setxy((((WidthS/2)-30)+24),35);
  LCD_setxy((((WidthS/2)-6)),35);
  LCD_deg12x16(10, 1); // ':'
  //LCD_setxy((((WidthS/2)-30)+36),35);
  LCD_setxy((((WidthS/2)+6)),35);
  LCD_deg12x16(sec[0], 1);
  //LCD_setxy((((WidthS/2)-30)+48),35);
  LCD_setxy((((WidthS/2)+18)),35);
  LCD_deg12x16(sec[1], 1);

// Battery
  k=(cur_Batt/5);
  if((k>BatCntr[0] && k>BatCntr[1]) || df_clip)  
  //  { LCD_setxy(5+20, 11+16); LCD_char(129, 1); }
  LCD_rectangle(12+16,11+15, 50+16,14+15, 1);
  k-=(int)BatCntr[1]; k*=(49-15); k/=(int)(BatCntr[2]-BatCntr[1]);
  k+=15; if(k>49) k=49;
  if(k>=13) { LCD_line(13+16, 12+15, k+16, 12+15, 1); LCD_line(13+16, 13+15, k+16, 13+15, 1); }
// Antenna 
  /*
  LCD_setxy(5, 16); LCD_char(130, 1);
  LCD_rectangle(12,16, 50,19, 1);
  k=(cur_Power/2); k*=(49-12); k/=500; k+=12; if(k>49) k=49;
  if(k>=13) { LCD_line(13, 17, k, 17, 1); LCD_line(13, 18, k, 18, 1); }
  */
break;
case 1:
//   
displ_trimmer_digital();
// 
//  LCD_setxy(5, 11); LCD_char(133, 1);
  /*
  sprintf(tmp,"%u%u:%u%u", min[0], min[1], sec[0], sec[1]);
  LCD_setxy(12, 12); LCD_wrs(tmp, 1);
  */
  //LCD_setxy(((WidthS/2)-30), 12); LCD_wrs(tmp, 1);
  LCD_setxy(((WidthS/2)-30),35);
  //LCD_setxy(12,24);
  LCD_deg12x16(min[0], 1);
  //LCD_setxy((((WidthS/2)-30)+12),35);
  LCD_setxy((((WidthS/2)-18)),35);
  LCD_deg12x16(min[1], 1);
  //LCD_setxy((((WidthS/2)-30)+24),35);
  LCD_setxy((((WidthS/2)-6)),35);
  LCD_deg12x16(10, 1); // ':'
  //LCD_setxy((((WidthS/2)-30)+36),35);
  LCD_setxy((((WidthS/2)+6)),35);
  LCD_deg12x16(sec[0], 1);
  //LCD_setxy((((WidthS/2)-30)+48),35);
  LCD_setxy((((WidthS/2)+18)),35);
  LCD_deg12x16(sec[1], 1);

//
// Battery  
//  LCD_setxy(5, 25); LCD_char(129, 1);
  i=cur_Batt/5;
  sprintf(tmp,"%-i.%-iV", i/10, i%10);
  if((i>BatCntr[0] && i>BatCntr[1]) || df_clip) 
    //{ LCD_setxy(12,22); LCD_wrs(tmp, 1); }
    { LCD_setxy(((WidthS/2)-13),24); LCD_wrs(tmp, 1); }
    //{ LCD_setxy(((WidthS/2)-30),22); LCD_wrs(tmp, 1); }
// Antenna 
  /*
//  LCD_setxy(50, 25); LCD_char(130, 1);
  sprintf(tmp,"%umA", cur_Power/5);
  //LCD_setxy(48,22); LCD_wrs(tmp, 1);
  LCD_setxy(((WidthS/2)+6),22); LCD_wrs(tmp, 1);
// 
  if(CalibrTemperature[1]==0) break;
  l=cur_Temperature;
  l*=CalibrTemperature[0];
  l/=CalibrTemperature[1];
  l-=50;
  ch=' ';
  if(dir_Temperature>0) ch=134; else if(dir_Temperature<0) ch=135;
  sprintf(tmp,"%c %dC%c", 131,  (signed int)l, ch);
  LCD_setxy(32,34); LCD_wrs(tmp, 1);
  */
break;
  }
}

//-------------------------------------------------------------
void displ_head (flash unsigned char * name)
{
flash unsigned char *p;
unsigned char x, l;
 
l=LCD_get_char_len('-'); l+=LCD_get_char_len(' '); l*=2;
p=name;
while(*p>=' ') { l+=LCD_get_char_len(*p); p++; }
x=(96/2)-(l/2);
LCD_setxy(x,0);
LCD_wrsf("- ", 1);
p=name;
while(*p>=' ') { LCD_char(*p, 1); p++; }
LCD_wrsf(" -", 1);
LCD_dashline(0, 8, 95, 8);
}

//-------------------------------------------------------------
extern unsigned char g_list_topitem;
extern unsigned char g_list_selitem;
extern unsigned char g_list_cnt;
extern bit f_edit;
extern bit f_edit_cur;
extern bit f_clip;
extern unsigned char pos[6];
extern unsigned char T[2];
extern MODEL_SET cur_model;
extern unsigned char cur_mode_ind;
extern unsigned char f_l;
//-------------------------------------------------------------
void displ_menu (void)
{
unsigned char i, att, x;
unsigned int k;
signed int v; 
unsigned char j, y1;

do
  {
  f_l=0;
  dg_list_topitem=g_list_topitem;
  dg_list_selitem=g_list_selitem;
  dg_list_cnt=g_list_cnt;
  df_edit=f_edit;
  df_edit_cur=f_edit_cur;
  df_clip=f_clip;
  for(i=0; i<6; i++) dpos[i]=pos[i];
  for(i=0; i<2; i++) dT[i]=T[i];
  dcur_model=cur_model;
  dcur_mode=&dcur_model.modes[cur_mode_ind];
  dcur_mode_ind=cur_mode_ind;
  }
while(f_l!=0);

LCD_clear();
switch(dpos[0])
  {
  case 0: // Main screen
  main_scr();
  break;
  case 1:
  switch(dpos[1])
    {
    case 0: //   
    displ_head("Main menu");
    list_displ(menuT0);
    break;
    case 1: // Select
    displ_head(menuT0[dpos[1]-1]);
    list_displ_names();
    break;
    case 2: // Model
    switch(dpos[2])
      {
      case 0:
        displ_head(menuT0[dpos[1]-1]);
        list_displ( menuT1);
      break;
      case 1: // CONTROLS
      switch(dpos[3])
        {
        case 0:
        displ_head(menuT1[dpos[2]-1]);
        list_displ(menuT2);
        break;
        default:
        displ_head(menuT2[dpos[3]-1]);
        if(!df_edit_cur) displ_controls(dpos[3]-1, dpos[4]);
        else displ_curve(dpos[3]-1, dpos[5]);
        break;
        }
      break;    
      case 2: // CHANNELS
      switch(dpos[3])
        {
        case 0:
        displ_head(menuT1[dpos[2]-1]);
        list_displ( menuT5);
        break;
        default:
        displ_head(menuT5[dpos[3]-1]);
        if(dpos[4]==0) displ_channel(dpos[3]-1);
        else if(dpos[4]==1) displ_mixer(dpos[3]-1);
        else if(dpos[4]==2)
          {
          displ_head(menuCh[1]);
          LCD_setxy(8+8,20+8); LCD_wrsf("Are you sure?",1);                
          } 
        break;
        }
      break;
      case 3: // 
      displ_head(menuT1[dpos[2]-1]); 
      LCD_setxy(8,20+8);            
      for (i=0; i<8; i++) 
        {
        if(dpos[3]==i) { att=0; if(df_edit) att=df_clip; } else att=1;
        x=posx;
        LCD_char(dcur_model.name[i], att);
        if(att==0) LCD_frame(x);
        }
      break;    
      case 4: //  
        displ_head(menuT1[dpos[2]-1]);
        LCD_setxy(8+18,20+8);
        LCD_wrsf(TypesModel[dcur_model.type], 1);
      break;
     // case 5: // 
     //   displ_head(menuT1[dpos[2]-1]);
     //   LCD_setxy(2,20); LCD_wrsf("Channel:", 1);
     //   sprintf(tmp,"%u", dcur_model.num_freq+PLL_OffDisplNCh);
     //   LCD_setxy(45,20); LCD_wrs(tmp, 1);
     //   LCD_setxy(2,29); LCD_wrsf("Freq:", 1);
     //   sprintf(tmp,"%u",  (dcur_model.num_freq));
     //   LCD_setxy(45,29); LCD_wrs(tmp, 1);
     // break;   
      case 5:  // 
        displ_head(menuT1[dpos[2]-1]); 
        LCD_setxy(30+4,20+8);
        LCD_wrsf(modulNames[dcur_model.modulation], 1); 
      break;
      case 6: // 
        displ_head(menuT1[dpos[2]-1]);
        LCD_setxy(34+10,20+8);
        //LCD_deg12x16(dcur_model.num_ch, 1);
        //LCD_setxy(4,28); LCD_wrsf("Max channels:", 1);
        //LCD_setxy(34+32,20+8);
        sprintf(tmp,"%u",  (dcur_model.num_ch));
        LCD_wrs(tmp, 1);
      break;
      case 7: // TIMER
      switch(dpos[3])
        {
        case 0: 
        displ_head(menuT1[dpos[2]-1]);
        list_displ( menuT3);
        break;
        case 1: //"- Set timer -"
        displ_head(menuT3[dpos[3]-1]);
        i=dcur_model.timer_set%60;
        sprintf(tmp,"%i:%i%i",dcur_model.timer_set/60, i/10, i%10);
        LCD_setxy(24+14,18+10); LCD_wrs(tmp,255);
        break;
        case 2:  // 
        displ_head(menuT3[dpos[3]-1]);
        LCD_setxy(30+6,20+8);
        LCD_wrsf(Timer_modes1[dcur_model.timer_mode],1);
        break;
        }
      break;  
      case 8:  //  
        displ_head(menuT1[dpos[2]-1]);
        LCD_dashline(0, 8, 83, 8);
        LCD_setxy(2+6,11+6); LCD_wrsf("From:",255);
        LCD_setxy(2+6,20+6); LCD_wrsf("To:",255);
        if(dpos[3]==0) { att=0; if(df_edit) att=df_clip; } else att=1;
        LCD_setxy(32+6, 11+6); LCD_wrsf(modeNames[dcur_model.type][dT[0]], att);
        if(dpos[3]==1) { att=0; if(df_edit) att=df_clip; } else att=1;
        LCD_setxy(32+6, 20+6); LCD_wrsf(modeNames[dcur_model.type][dT[1]], att);
        if(dpos[3]==2) att=0; else att=1;
        LCD_setxy(32+10,34+10); LCD_wrsf("OK", att);
      break;
      case 9: // Reset    
        displ_head(menuT1[dpos[2]-1]);
        LCD_setxy(8+8,20+8); LCD_wrsf("Are you sure?",1);                
      break;
      case 11: // Confirm
        displ_head("All change");
        list_displ( menuT7);
      break;  
      }
    break;
    case 3: //  
      displ_head(menuT0[dpos[1]-1]);
      LCD_setxy(2+6,11+6); LCD_wrsf("From:",255);
      LCD_setxy(2+6,20+6); LCD_wrsf("To:",255);
      if(dpos[2]==0) { att=0; if(df_edit) att=df_clip; } else att=1;
      LCD_setxy(32+6, 11+6); x=posx;
      for (i=0; i<8; i++) LCD_char(EEPR_models[dT[0]].name[i], att);
      if(att==0) LCD_frame(x);
      if(dpos[2]==1) { att=0; if(df_edit) att=df_clip; } else att=1;
      LCD_setxy(32+6, 20+6); x=posx;
      for (i=0; i<8; i++) LCD_char(EEPR_models[dT[1]].name[i], att);
      if(att==0) LCD_frame(x);
      if(dpos[2]==2) att=0; else att=1;
      LCD_setxy(32+10,34+10); LCD_wrsf("OK", att);
    break;
    case 4:
    switch(dpos[2])
      {
      case 0:  
        displ_head(menuT0[dpos[1]-1]);
        list_displ( menuT4);
      break;
      case 1: // "Sound"
        displ_head(menuT4[dpos[2]-1]);
        LCD_setxy(32+8,20+8);
        if (f_sound_en) LCD_wrsf("ON",255); 
        else LCD_wrsf("OFF",255);
      break;  
      case 2:
        switch(dpos[3])
          {
        case 0:
          displ_head(menuT4[dpos[2]-1]);
          list_displ( menuT6);
        break;
        case 1: // "Battery"
          displ_head(menuT6[dpos[3]-1]);
          for(i=0, x=11; i<3; i++, x+=9)
            {
            if(dpos[4]==i && !df_edit) att=0; else att=1;
            if(att==0) LCD_fillrect(0, x-1, 40, x+7, 1);
            LCD_setxy(2,x); LCD_wrsf(menuT8[i], att);
            sprintf(tmp,"%-i.%-i", BatCntr[i]/10, BatCntr[i]%10);
            if(dpos[4]==i && df_edit) att=df_clip; else att=1;
            LCD_setxy(45,x); LCD_wrs(tmp, att);
            }
        break;
        case 2: // "Throttle
          displ_head(menuT6[dpos[3]-1]);
          LCD_setxy(32+8,20+8);
        if (f_throttle_en) LCD_wrsf("ON",255); 
        else LCD_wrsf("OFF",255);
          //sprintf(tmp,"Alarm: %i%c", gAntCntr, '%');
          //LCD_setxy(2,20); LCD_wrs(tmp, 1);
        break;
          }
      break;  
      case 3: // "Monitor"
        displ_head(menuT4[dpos[2]-1]);
        displ_monitor();
      break;  
            case 4: // "Tachometer"
         displ_head(menuT4[dpos[2]-1]);
        for(i=0, k=0; i<SIZE_RPM_BUFF; i++) k+=gRPM[i];
        k=k*(40/2);
        sprintf(tmp,"%u RPM", k);
        LCD_setxy(16,20); LCD_wrs(tmp, 1);
       
        v=out_ch[2]-2250;
          sprintf(tmp,"Throttle");  
          LCD_setxy(28,40); LCD_wrs(tmp, 1);
            y1=58;
            LCD_line(14, y1, 78, y1, 1);
            for(j=0, x=14; j<17; j++, x+=4)
                { LCD_pixel(x, y1-1, 1); if(!(j%2)) LCD_pixel(x, y1-2, 1); }
            v*=32; v/=900; v+=46;
            LCD_pixel(v, y1-1-2, 1);
            LCD_line(v-1, y1-2-2, v+1, y1-2-2, 1);
            LCD_line(v-2, y1-3-2, v+2, y1-3-2, 1);
      break;
      
      case 5: // PC/TX Link
      break;
      
      case 6: // Load Config
      break;
           
      case 7: // Version
        displ_head(menuT4[dpos[2]-1]);
        LCD_setxy(2+2,20); LCD_wrsf(_str_VER, 1);
        LCD_setxy(24+4,38); LCD_wrsf(_str_Co, 1);
      break;  
      }
    break;
    }
  break;
  }      
LCD_refresh();
}
//-------------------------------------------------------------
